	@echo off
	REM *************** Begin Standard Header - Do not add comments here ***************
	REM 
	REM 
	REM File Name: changeTklmPassword.bat
	REM
	REM
	REM Licensed Materials - Property of IBM
    REM
    REM 5724-T60 5608-A91
    REM (C) Copyright IBM Corp. 2009  All Rights Reserved
    REM
    REM US Government Users Restricted Rights - Use, duplication, or
    REM disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
    REM
	REM **************************** End Standard Header *******************************


	setlocal enabledelayedexpansion
	
	if %1X==-?X goto printUsage
	if %3X==X goto printUsage
	if NOT %4X==X goto printUsage
	goto continue1

	:printUsage
	 echo changeTklmPassword.bat [ TIP_USERNAME TIP_PASSWORD TKLMADMIN_PASSWORD] ^| [-?]
	 echo  changes Tivoli Key Lifecycle Manager tklmadmin's password,
	 echo   where 
	 echo   -? Returns this command usage
	 echo  TIP_USERNAME is the Tivoli Integrated Portal user name 
	 echo  TIP_PASSWORD is the Tivoli Integrated Portal password for TIP_USERNAME
	 echo  TKLMADMIN_PASSWORD is the new tklmadmin's password
	 echo  Windows TIP location: %SystemDrive%\IBM\tivoli\tip 
	 echo  AIX, Solaris, Linux TIP location: /opt/IBM/tivoli/tip 
	 echo  To override the default TIP location, set the environment variable TIP_HOME prior to running. 
	 echo  Example of the command with logging: 
	 echo  changeTklmPassword tipadmin tippass tklmpass ^>^> changeTklmPwd.log
	 exit /B 0

	:continue1
	set TIPADMIN=%1
	set TIPPWD=%2
	set TKLMNewPassword=%3

	set tipHome=%TIP_HOME%
	if Exist "%tipHome%" goto changeIt
	set tipHome=%SystemDrive%\IBM\tivoli\tip
	if Exist %tipHome% goto changeIt
	SET /P tipHome=Enter TIP_HOME path(if you have multiple TIP installation, make sure to enter the correct one: 
	if Exist %tipHome% goto changeIt
	echo TIP_HOME: %tipHome% is not a valid TIP home
	echo Exit Code=3. Error: found problem with TIP_HOME.
	exit /B 3	
	
	:changeIt
	set registryFilePath=%tipHome%\profiles\TIPProfile\config\cells\TIPCell
	set registryFile=fileRegistry.xml
	set tipTemp=%tipHome%\temp
	if EXIST "%registryFilePath%\%registryFile%" goto backup
	echo Exit Code=8. Error: TIP Registry file is missing,it could be bad TIP_HOME.
	exit /B 8
	
	:backup
	echo Back up the registry file: %registryFilePath%\%registryFile% to %tipTemp% ...
	copy "%registryFilePath%\%registryFile%"  "%tipTemp%\%registryFile%"
	
	echo Running wsadmin to change tklmadmin's password ...
	call "%tipHome%\bin\wsadmin.bat"  -username %TIPADMIN% -password %TIPPWD% -profileName TIPProfile -lang jython ^
-c "AdminTask.changeFileRegistryAccountPassword ('-userId tklmadmin -password %TKLMNewPassword%')" "AdminConfig.save()" 
	if %ERRORLEVEL%==0 goto restartServer
	echo  Exit Code=2. Error: Failed to change tklmadmin's password, the error code from wsadmin is %ERRORLEVEL%.
	exit /B 2
	
	:restartServer
	echo Restart the WebSphere server1, this may take several minutes ...
	call "%tipHome%\bin\stopServer.bat" server1 -username %TIPADMIN% -password %TIPPWD%
	if %ERRORLEVEL%==0 goto startServer
	echo  Exit Code=4, Error: Failed to stop WAS server1, the error code from stopServer is %ERRORLEVEL%.
	exit /B 4
	
	:startServer
	call "%tipHome%\bin\startServer.bat" server1
	if %ERRORLEVEL%==0 goto eof
	echo  Exit Code=5, Error: Failed to start WAS server1, the error code from startServer is %ERRORLEVEL%.
	exit /B 5
	:eof
	echo tklmadmin's password have been successfully changed

	
	exit /B 0







